
randomMonicPolynomial=method(Options=>{Height=>20})
randomMonicPolynomial(ZZ,Ring) := opt -> (n,R) -> (
    kk:= coefficientRing R;
    x:= R_0;
    if char R >0 then x^n+sum(n,i->random(kk)*x^i) else (
	m := floor (opt.Height/2);
	x^n+sum(n,i->(random(ZZ,Height=>opt.Height)-m)*x^i))
    )

degreesOfFactors=method()
degreesOfFactors(RingElement) := f -> (
    L1 := toList factor f;
    L2 := apply(L1,a->first toList a);
    L3 := sort apply(L2,a->(degree a)_0);
    if L3_0==0 then L3=drop(L3,1) else L3
    )
    
randomPrimitivePolynomial=method(Options=>{Height=>20})
randomPrimitivePolynomial(ZZ,Ring) := opt-> (n,R) -> (
    assert(char R == 0);
    m := floor (opt.Height/2);
    x := R_0;
    cn := random(ZZ,Height=>m-1)+1;
    coeff := append(apply(n,i->random(ZZ,Height=>2*m)-m),cn);
    d:=gcd(coeff);
    if d>1 then coeff=apply(coeff,c->lift(c/d,ZZ));
    sum(n+1,i->coeff_i*x^i)
    )      

makeListOfPrimes = (startValue,lengthOfTheSequence) -> (
    primes:= {nextPrime startValue};
    while #primes < lengthOfTheSequence do (
	primes=append(primes, nextPrime(last primes+1))
	);
    primes)

principlePart = f -> (
    coef := sub((coefficients f)_1,ZZ);
    d := gcd flatten entries coef; 
    ((coefficients f)_0*lift(1/d*(coef**QQ),ZZ))_(0,0)
    )

-- computes the principle part of a polynomial

principlePart = f -> (
    coef := sub((coefficients f)_1,ZZ);
    d := gcd flatten entries coef; 
    ((coefficients f)_0*lift(1/d*(coef**QQ),ZZ))_(0,0)
    );

-- computes the supremum norm of a polynomial

supNorm = f -> (
    max (flatten entries sub((coefficients f)_1,ZZ)/abs));

-- computes the 1-norm of a polynomial

oneNorm = f -> sum(flatten entries sub((coefficients f)_1,ZZ)/abs);


-- checks, whether a given polynomial is square-free

squareFree = f-> (
    P=ring f; 
    f'=diff(P_0,f);
    (degree gcd(f,f'))_0==0);

-- computes the bound on the coefficients

boundB = f -> ( 
    n := (degree f)_0;
    A := supNorm f;
    lc :=leadCoefficient f;
    ceiling (sqrt(n+1)*2^n*A*lc)
    );

-- computes a sufficiently large prime number and
-- returns the input modulo this prime number

findBigPrime = f -> (
    B := boundB f;
    P :=ring f; 
    p :=nextPrime (2*B);
    R := ZZ/p[gens P];
    fp := sub(f,R);
    while ( not gcd(fp,diff(R_0,fp)) == 1) do (
	p=nextPrime(p+2);
	R = ZZ/p[gens P];
        fp = sub(f,R); );
    (B,fp)
    );


end;


restart 
load("factorisationBigPrime.m2")
peek loadedFiles

P = ZZ[x]
f = product apply(4,i-> randomPrimitivePolynomial(random(4)+2,P,Height=>10))

-- since Macaulay2 cannot handly arbitrarily large primes,
-- we use this loop to find a suitable example

while(boundB f > 2^28) do
(
    f = product apply(4,i-> randomPrimitivePolynomial(random(4)+2,P,Height=>10));
    if not squareFree f then continue;
)

b = leadCoefficient f


-- compute the big prime and factor f modulo that prime
(B,fp) = findBigPrime f
T' = if b!=1 then drop(toList factor fp, -1) else toList factor fp

-- characteristic of the prime field

p = char ring fp

-- initialisation

T = toList(1..#T')
fstar = f
T'' = apply(T',g->sub(first g,P))
apply(T'',g->supNorm g <p/2)
R = ring fp
s=1
G={}

-- check, whether all coefficients are divisible by p

coeffs = sub((coefficients (value( b*product(T,i->T''_(i-1)))-f))_1,ZZ)
coeffs % ideal p == 0



-- factor combination
-- this prints the intermediate values of gstar, hstar, S and T

while (2*s <= #T) do 
(
	TS = subsets(T,s);
 	scan(TS,S->
	    (
		print (S,T);
		gstar= sub(sub(value(b*product(S,i->T''_(i-1))),R),P);
		print gstar;
        	hstar = sub(sub(value(b*product(select(T,i-> not member(i,S)),i->T''_(i-1))),R),P);
		print hstar;
                if oneNorm(gstar)*oneNorm(hstar) <= B then 
		(
	                G=append(G,principlePart gstar);
	    		T=select(T,i->not member(i,S));
	    		fstar=principlePart hstar;
	    		b=leadCoefficient fstar;
		);
		        if 2*s > #T then (print "break"; break)
	     )
	 );
	s=s+1
)

-- computes the final result and compares against the factorisation of f over ZZ

G = append(G,fstar)
factor f       	   

